SIMPLER_ANIMAL_SETUP("retromario", "IDLE", "DASH", "JUMP", "HALT", "SITT", "OUCH", "TPSP", "BTPS", 
"BIDL", "BRUN", "BJMP", "BHLT", "BSIT", 
"FIDL", "FRUN", "FJMP", "FHLT", "FSIT",
"BFID", "BFRN", "BFJM", "BFHL", "BFST"
) -- Initiate character and custom Sprite2s.

--Other Freeslot stuff (If there is a way to shorten this, I would do it.)
freeslot("SKINCOLOR_FIREBALL", "SKINCOLOR_SHELLED",
"SKINCOLOR_STARMAN1", "SKINCOLOR_STARMAN2","SKINCOLOR_STARMAN3",
"sfx_mbitjm", "sfx_mbitbj", "sfx_mbitdg", "sfx_mbitsc", "sfx_mbitcn", "sfx_mbitfr", "sfx_mbitrm", "sfx_mbitgr",
"SPR_FRBL", "SPR_SHLL", "SPR_COIN", "SPR_PNTS", "SPR_BLLT", "SPR_PSNM", 
"S_RETROFIREBALL", "S_RETROSHELL", "S_RETROBULLET", "S_RETROPOISON",
"S_RETROCOINSTART", "S_RETROCOIN1", "S_RETROCOIN2", "S_RETROCOIN3", "S_RETROPOINTS", "MT_RETROPOINTS")

--Console/Host Variables
CV_RegisterVar({name = "RetroDebug",
				description = "Renders debug text",
				defaultvalue = "Off",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "RetroJumping", 
				description = "Allows Retro Mario's jumping ability",
				defaultvalue = "On",
				flags = CV_NETVAR, 
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "RetroJumpHeight",
				description = "How high Retro Mario can jump if enabled (1 = 1/4 Fracunit)",
				defaultvalue = 50,
				flags = CV_NETVAR,
				PossibleValue = CV_Unsigned})
CV_RegisterVar({name = "RetroRechargeTime",
				description = "How long it takes for Retro mario's jump to recharge (1 = 1 second)",
				defaultvalue = 20,
				flags = CV_NETVAR,
				PossibleValue = CV_Unsigned})
CV_RegisterVar({name = "RetroEarlyJump",
				description = "Allows mario to jump early at reduced height dependant on current charge",
				defaultvalue = "Off",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})	
CV_RegisterVar({name = "RetroJumpWhip",
				description = "Allows Mario to instawhip while jumping is enabled",
				defaultvalue = "Off",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})

--Item Reskin Command
local localRetroReskin
COM_AddCommand("retroitemreskin", function(player, var)
	if tonumber(var) == 2 then
        CONS_Printf(player, "Warning: Retro Overflow")
		localRetroReskin = 2
    elseif tonumber(var) == 1 then
        CONS_Printf(player, "Retro Mario's reskinned items are on!")
		localRetroReskin = 1
    elseif tonumber(var) == 0 then
        CONS_Printf(player, "Retro Mario's reskinned items are off!")
		localRetroReskin = 0
    else
		CONS_Printf(player, "0: Disabled.")
		CONS_Printf(player, "1: Enabled.")
		CONS_Printf(player, "2: ?????")
    end
end, COM_LOCAL)
--Local Jumping Command
local localRetroJump
COM_AddCommand("retrolocaljump", function(player, var)
	if tonumber(var) == 1 then
		CONS_Printf(player, "Jumping turned on; Instawhipe Disabled (Unless the host turned on JumpWhip).")
		localRetroJump = 1
	elseif tonumber(var) == 0 then
		CONS_Printf(player, "Jumping turned off; Instawhip Restored")
		localRetroJump = 0
	else
		CONS_Printf(player, "Toggles only your jumps (only if they were enabled by the host)")
		CONS_Printf(player, "0: Disabled.")
		CONS_Printf(player, "1: Enabled.")
	end
	if player.mo.skin ~= "retromario" then
		CONS_Printf(player, "Warning: Could only be utilized by Retro Mario")
	end
end, COM_LOCAL)
--Skincolors
skincolors[SKINCOLOR_FIREBALL] = {
	name = "Fireball",
	ramp = {0,49,50,51,53,56,57,38,39,62,70,79,236,237,238,239},
    invcolor = SKINCOLOR_GREEN,
    chatcolor = V_REDMAP,
    accessible = true
}
skincolors[SKINCOLOR_SHELLED] = {
    name = "Shelled",
    ramp = {0,49,50,51,53,68,78,104,105,105,94,79,236,237,238,239},
    invcolor = SKINCOLOR_RED,
    chatcolor = V_GREENMAP,
    accessible = true
} 

--Invincibility exclusive colors
skincolors[SKINCOLOR_STARMAN1] = {
    name = "STARMAN1",
    ramp = {0,0,0,0,0,0,104,104,104,104,104,53,53,53,53,53},
    invcolor = SKINCOLOR_RED,
    chatcolor = V_INVERTMAP,
    accessible = false
}
skincolors[SKINCOLOR_STARMAN2] = {
    name = "STARMAN2",
    ramp = {0,0,0,0,0,0,38,38,38,38,38,53,53,53,53,53},
    invcolor = SKINCOLOR_RED,
    chatcolor = V_INVERTMAP,
    accessible = false
}
skincolors[SKINCOLOR_STARMAN3] = {
    name = "STARMAN3",
    ramp = {216,216,216,216,216,216,31,31,31,31,31,59,59,59,59,59},
    invcolor = SKINCOLOR_RED,
    chatcolor = V_INVERTMAP,
    accessible = false
}

--Item Reskins and Effects
mobjinfo[MT_RETROPOINTS] = {
	doomednum = -1,
	spawnstate = S_RETROPOINTS,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
states[S_RETROFIREBALL] = {
	sprite = SPR_FRBL,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	tics = -1,
	var1 = 3,
	var2 = 2,
	nextstate = S_RETROFIREBALL,
}
states[S_RETROCOINSTART] = {
	sprite = SPR_COIN,
	frame = A,
	tics = 4,
	nextstate = S_RETROCOIN1,
}
states[S_RETROCOIN1] = {
	sprite = SPR_COIN,
	frame = B,
	tics = 4,
	nextstate = S_RETROCOIN2,
}
states[S_RETROCOIN2] = {
	sprite = SPR_COIN,
	frame = C,
	tics = 4,
	nextstate = S_RETROCOIN3,
}
states[S_RETROCOIN3] = {
	sprite = SPR_COIN,
	frame = D,
	tics = 4,
	nextstate = S_RETROPOINTS,
}
states[S_RETROPOINTS] = {
	sprite = SPR_PNTS,
	frame = A,
	tics = 35,
	nextstate = S_INVISIBLE,
}
states[S_RETROSHELL] = {
	sprite = SPR_SHLL,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 4,
	nextstate = S_RETROSHELL,
}
states[S_RETROBULLET] = {
	sprite = SPR_BLLT,
	frame = A,
	tics = 4,
	nextstate = S_RETROBULLET,
}
states[S_RETROPOISON] = {
	sprite = SPR_PSNM,
	frame = A,
	tics = 4,
	nextstate = S_RETROPOISON,
}

local Retrofunc = {}

--Count Current Players in game
function Retrofunc.countCurrentPlayers()
	local counter = 0
	for i=0,#players - 1 do
		if players[i] ~= nil then
			counter = $ + 1
		end
	end
	return counter
end

--Userdata spawn initializer
addHook("PlayerSpawn", function(player) 
	if player.mo.skin == "retromario" then
		player.jumping = 0 
		player.jumpcooldown = 0 
		player.jumprechargetimer = 0
		player.jumpcharge = 0
		player.jumpchargeflashtimer = 0
		player.jumpchargeflash = false
		player.jumpfirstwait = 0
		player.jumpfirststop = false
		player.jumpattack = false
		player.flare = 0 
		player.flarebuffer = 0 
		player.flarebuffer2 = 0 
		player.flarewait = false
		player.flaresetup = false
		player.fireflowerflash = false
		player.fireflowertimer = 0
		player.starmantimer = 0
		if localRetroReskin == nil then
			localRetroReskin = 1
		end
		if localRetroJump == nil then
			localRetroJump = 1
		end
	else
		if localRetroReskin == nil then
			localRetroReskin = 1
		end
		return
	end
end)

local helpers = _G["SIMPLER_ANIMAL_HELPERS"]

--Animations
function SIMPLER_ANIMAL_HOOKS.retro_mario_hook(mobj)
  if helpers.getSkin(mobj) == "retromario"
    local player = helpers.getPlayer(mobj)
	/*
	if gametype ==  1 or gametype == 2 then
		print("CoolTime")
	else
		print("fuck")
	end
	*/
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
	  S_StopSoundByID(mobj, sfx_s3k3e)
    end
	--Jump Sound 
	if helpers.isAirborne(mobj) then 
		if helpers.isAscending(mobj) and player.jumping == 0 and not player.fastfall and mobj.sprite2 ~= SPR2_DEAD0 then
			if player.growshrinktimer > 0 then
				S_StartSoundAtVolume(mobj, sfx_mbitbj, 255)
			elseif player.growshrinktimer <= 0 then
				S_StartSoundAtVolume(mobj, sfx_mbitjm, 255)
			end
			player.jumping = 1
		elseif helpers.isDescending(mobj) or player.fastfall then
			player.jumping = 0
		end
	end
	--Invincibility Palette Swap
	if player.invincibilitytimer > 0 then
		player.mo.colorized = false
		if player.starmantimer == nil then player.starmantimer = 0 return end
		if player.starmantimer >= 0 and player.starmantimer <= 3 then
			player.mo.color = SKINCOLOR_STARMAN1
			player.starmantimer = $ + 1
		elseif player.starmantimer >= 4 and player.starmantimer <= 7 then
			player.mo.color = SKINCOLOR_STARMAN2
			player.starmantimer = $ + 1
		elseif player.starmantimer >= 8 and player.starmantimer <= 11 then
			player.mo.color = SKINCOLOR_STARMAN3
			player.starmantimer = $ + 1
		elseif player.starmantimer >= 12 and player.starmantimer <= 15 then
			player.mo.color = player.skincolor
			player.starmantimer = $ + 1
		elseif player.starmantimer >= 12
			player.starmantimer = 0
		end
	end
	if player.flare == nil then player.flare = 0 return end
	--Animation Controller
	--Base Form
	if player.growshrinktimer <= 0 and player.flare == 0 then
		if mobj.sprite2 == SPR2_GOAL then return 
		elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
		elseif player.curshield == 4 then return "TPSP", A, A, H --spintop spinning
		elseif mobj.sprite2 == SPR2_STIL or mobj.sprite2 == SPR2_STIN then return "IDLE", A, A, A -- https://git.do.srb2.org/KartKrew/RingRacers/-/issues/151
		elseif player.spindash then return "DASH", A, A, C -- Spindash, start at A, loop back to A after C.
		elseif helpers.isTricking(mobj) or player.fastfall then return "SITT", A, A, A	
		elseif player.respawn.timer then return "OUCH", A, A, A
		elseif helpers.isAirborne(mobj) then return "JUMP", A, A, A
		elseif mobj.sprite2 == SPR2_SLWN or mobj.sprite2 == SPR2_FSTN
			if (player.cmd.buttons & BT_BRAKE) and abs(player.speed) > FRACUNIT then
				S_StartSound(mobj, sfx_mbitdg)
				return "HALT", A, A, A
			elseif helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "DASH", A, A, C
			else -- Moving sideways/backwards.
				if (player.cmd.buttons & BT_ACCELERATE) and abs(player.speed) > FRACUNIT
				S_StartSound(mobj, sfx_mbitdg)
				return "HALT", A, A, A
			else
				helpers.SquaredSlow(mobj, 1)
				return "DASH", A, A, C
			end
		end
    elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
	  if (player.cmd.buttons & BT_BRAKE)
	    S_StartSound(mobj, sfx_mbitdg)
	    return "HALT", A, A, A
	  else
        helpers.SquaredSlow(mobj, -1)
        return "DASH", A, A, C
	  end
    end
	--Big Form
	elseif player.growshrinktimer > 0 and player.flare == 0 then
		player.mo.spritexscale = FRACUNIT - FRACUNIT/3
		player.mo.spriteyscale = FRACUNIT - FRACUNIT/3
		if mobj.sprite2 == SPR2_GOAL then return 
		elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
		elseif player.curshield == 4 then return "BTPS", A, A, H --spintop spinning
		elseif mobj.sprite2 == SPR2_STIL or mobj.sprite2 == SPR2_STIN then return "BIDL", A, A, A 
		elseif player.spindash then return "BRUN", A, A, C -- Spindash, start at A, loop back to A after C.
		elseif helpers.isTricking(mobj) or player.fastfall then return "BSIT", A, A, A	
		elseif player.respawn.timer then return "OUCH", A, A, A
		elseif helpers.isAirborne(mobj) then return "BJMP", A, A, A
		elseif mobj.sprite2 == SPR2_SLWN or mobj.sprite2 == SPR2_FSTN
			if (player.cmd.buttons & BT_BRAKE) and abs(player.speed) > FRACUNIT then
				S_StartSound(mobj, sfx_mbitdg)
				return "BHLT", A, A, A
			elseif helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "BRUN", A, A, C
			else -- Moving sideways/backwards.
				if (player.cmd.buttons & BT_ACCELERATE) and abs(player.speed) > FRACUNIT
					S_StartSound(mobj, sfx_mbitdg)
					return "BHLT", A, A, A
				else
					helpers.SquaredSlow(mobj, 1)
					return "BRUN", A, A, C
				end
			end
        elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
			if (player.cmd.buttons & BT_BRAKE)
				S_StartSound(mobj, sfx_mbitdg)
				return "BHLT", A, A, A
			else
				helpers.SquaredSlow(mobj, -1)
				return "BRUN", A, A, C
			end
	    elseif mobj.sprite2 == SPR2_FSTN then return "BRUN", A, A, C
		end
	--Fire Form
	elseif player.growshrinktimer <= 0 and player.flare > 0 then
		if mobj.sprite2 == SPR2_GOAL then return 
		elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
		elseif mobj.sprite2 == SPR2_STIL or mobj.sprite2 == SPR2_STIN then return "FIDL", A, A, A 
		elseif player.spindash then return "FRUN", A, A, C -- Spindash, start at A, loop back to A after C.
		elseif helpers.isTricking(mobj) or player.fastfall then return "FSIT", A, A, A	
		elseif player.respawn.timer then return "OUCH", A, A, A
		elseif helpers.isAirborne(mobj) then return "FJMP", A, A, A
		elseif mobj.sprite2 == SPR2_SLWN or mobj.sprite2 == SPR2_FSTN
			if (player.cmd.buttons & BT_BRAKE) and abs(player.speed) > FRACUNIT then
				S_StartSound(mobj, sfx_mbitdg)
				return "FHLT", A, A, A
			elseif helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "FRUN", A, A, C
			else -- Moving sideways/backwards.
				if (player.cmd.buttons & BT_ACCELERATE) and abs(player.speed) > FRACUNIT
					S_StartSound(mobj, sfx_mbitdg)
					return "FHLT", A, A, A
				else
					helpers.SquaredSlow(mobj, 1)
					return "FRUN", A, A, C
				end
			end
        elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
			if (player.cmd.buttons & BT_BRAKE)
				S_StartSound(mobj, sfx_mbitdg)
				return "FHLT", A, A, A
			else
				helpers.SquaredSlow(mobj, -1)
				return "FRUN", A, A, C
			end
	    elseif mobj.sprite2 == SPR2_FSTN then return "FRUN", A, A, C
		end
	--Big Fire Form
	elseif player.growshrinktimer > 0 and player.flare > 0 then
		player.mo.spritexscale = FRACUNIT - FRACUNIT/3
		player.mo.spriteyscale = FRACUNIT - FRACUNIT/3
		if mobj.sprite2 == SPR2_GOAL then return 
		elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
		elseif mobj.sprite2 == SPR2_STIL or mobj.sprite2 == SPR2_STIN then return "BFID", A, A, A 
		elseif player.spindash then return "BFRN", A, A, C -- Spindash, start at A, loop back to A after C.
		elseif helpers.isTricking(mobj) or player.fastfall then return "BFST", A, A, A	
		elseif player.respawn.timer then return "OUCH", A, A, A
		elseif helpers.isAirborne(mobj) then return "BFJM", A, A, A
		elseif mobj.sprite2 == SPR2_SLWN or mobj.sprite2 == SPR2_FSTN
			if (player.cmd.buttons & BT_BRAKE) and abs(player.speed) > FRACUNIT then
				S_StartSound(mobj, sfx_mbitdg)
				return "BFHL", A, A, A
			elseif helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "BFRN", A, A, C
			else -- Moving sideways/backwards.
				if (player.cmd.buttons & BT_ACCELERATE) and abs(player.speed) > FRACUNIT
					S_StartSound(mobj, sfx_mbitdg)
					return "BFHL", A, A, A
				else
					helpers.SquaredSlow(mobj, 1)
					return "BFRN", A, A, C
				end
			end
		elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
			if (player.cmd.buttons & BT_BRAKE)
				S_StartSound(mobj, sfx_mbitdg)
				return "BFHL", A, A, A
			else
				helpers.SquaredSlow(mobj, -1)
				return "BFRN", A, A, C
			end
		elseif mobj.sprite2 == SPR2_FSTN then return "BFRN", A, A, C
		end
	end
end
end

--Jump Controller
addHook("PlayerThink", function(player) 
	if player.mo == nil then return end
	if player.mo.skin == "retromario" and player.mo.skin ~= "heavymagician" then
	
		local jumpheight = (FRACUNIT/4)*CV_FindVar("RetroJumpHeight").value
		local jumptimer = TICRATE*CV_FindVar("RetroRechargeTime").value
		local earlyjump
		local freejump
		
		--Abort Function if Jumping is disabled or during battle/special gamemodes
		if (CV_FindVar("RetroJumping").value == 0 or localRetroJump == 0) or gametype == 1 then return end
		
		--Setting the Early Jump value
		if CV_FindVar("RetroEarlyJump").value == 0 then
			earlyjump = false
		else
			earlyjump = true
		end
		
		--Freeplay/Special Free jump
		if Retrofunc.countCurrentPlayers() == 1 or gametype == 2 then
			freejump = true
		elseif Retrofunc.countCurrentPlayers() > 1 and gametype ~= 2 then
			freejump = false
		end
		
		--Special Height Doubler
		if gametype == 2 then
			jumpheight = (FRACUNIT/2)*CV_FindVar("RetroJumpHeight").value
		end
		
		--Hud Timer Communicator
		if player.jumprechargetimer == jumptimer then
			if player.jumpchargeflash == false then
				if player.jumpchargeflashtimer < 15 then
					player.jumpchargeflashtimer = $ + 1
				elseif player.jumpchargeflashtimer == 15 then
					player.jumpchargeflash = true
				end
			elseif player.jumpchargeflash == true then
				if player.jumpchargeflashtimer > 0 then
					player.jumpchargeflashtimer = $ - 1
				elseif player.jumpchargeflashtimer == 0 then
					player.jumpchargeflash = false
				end
			end
		else
			player.jumpchargeflashtimer = 15
			player.jumpchargeflash = true
		end
		
		--First Place Jump Charge Preventer Stuff
		if (player.position == 1 or player.laps == 0) and freejump == false then
			player.jumpfirststop = true
			player.jumpfirstwait = 105
		else
			if player.jumpfirstwait == nil then return end
			if player.jumpfirstwait > 0 then
				player.jumpfirstwait = $ - 1
			else
				player.jumpfirststop = false
			end
		end
		
		--Jump attacking
		if player.jumpattack == true and P_IsObjectOnGround(player.mo) == true then
			player.jumpattack = false
		end
		
		--The actual jumping
		if CV_FindVar("RetroJumping").value == 1 then
			if player.jumprechargetimer == nil then return end
			--Timer Overflow Fixer
			if player.jumprechargetimer > jumptimer then
				player.jumprechargetimer = jumptimer
			end
			--Timer Charger
			if player.jumprechargetimer ~= jumptimer and player.jumpfirststop == false and freejump == false then
				player.jumprechargetimer = $ + 1
			elseif freejump == true then
				player.jumprechargetimer = jumptimer
			end	
			--LuaA Button press to Jump
			if (player.cmd.buttons & BT_LUAA) == BT_LUAA and P_IsObjectOnGround(player.mo) == true and not player.fastfall then --It isn't free
				if player.jumprechargetimer == jumptimer and freejump == false then -- Jump
					P_SetObjectMomZ(player.mo, jumpheight, true)
					player.jumprechargetimer = 0
					player.jumpattack = true
				elseif player.jumprechargetimer ~= jumptimer and earlyjump == true and freejump == false then -- Early Jump
					for i = 1,11 do
						if player.jumprechargetimer >= i*(jumptimer/12) and player.jumprechargetimer < (i+1)*(jumptimer/12)
							P_SetObjectMomZ(player.mo, (jumpheight*i)/12, true)
							player.jumprechargetimer = 0
						end
					end
				elseif freejump == true then --It's Free Real Estate
					P_SetObjectMomZ(player.mo, jumpheight, true)
					player.jumpattack = true
				end
			end
		end
	end
end)

--Jump Stomping
addHook("MobjMoveCollide", function(victim, mario)
	if mario.valid and victim.valid and mario.type == MT_PLAYER then
		if mario.skin == "retromario" and mario ~= victim then
			if mario.player.jumpattack == true then
				if (mario.z > victim.z+(5*FRACUNIT)) and (mario.z < victim.z+(15*FRACUNIT)) and (mario.momz < victim.momz)
					P_DamageMobj(victim, mario, mario, 3, DMG_NORMAL)
					P_SetObjectMomZ(mario, (50*(FRACUNIT/4))+abs(mario.momz)+victim.momz, true)
					victim.player.squishedcountdown = 175
					victim.player.mo.spriteyscale = FRACUNIT/2
					return
				end
			end
		end
	end
end, MT_PLAYER)

--Ufo Stomping 
addHook("MobjMoveCollide", function(victim, mario)
	if mario.valid and victim.valid and mario.type == MT_PLAYER then
		if mario.skin == "retromario" and mario ~= victim then
			if mario.player.jumpattack == true then
				if (mario.z > victim.z-(20*FRACUNIT)) and (mario.z < victim.z+(60*FRACUNIT)) and (mario.momz < victim.momz) and victim.health >= 10 then
					print(victim.health)
					if victim.health >= 20 then
						victim.health = $ - 20
					else
						victim.health = 10
					end
					P_DamageMobj(victim, mario, mario, 1, DMG_NORMAL)
					P_SetObjectMomZ(mario, (50*(FRACUNIT/2))+abs(mario.momz)+victim.momz, true)
					print(victim.health)
					return
				end
			end
		end
	end
end, MT_SPECIAL_UFO)

--Hyudoro Stealing Flame Shield from Fire Flower
addHook("MobjMoveCollide", function(hyudoro, mario)
	if mario.valid and hyudoro.valid and mario.type == MT_PLAYER and hyudoro.type == (MT_HYUDORO or MT_HYUDORO_CENTER) and mario ~= hyudoro then
		if mario.player.flare == nil then return end
		if mario.player.flare >= 1 then
			mario.player.flare = 0
		else
			return
		end
	end
end, MT_HYUDORO)

--Squished after being jumped on
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.squishedcountdown == nil then 
			player.squishedcountdown = 0
		elseif player.squishedcountdown >= 1 then
			player.mo.spriteyscale = FRACUNIT/2
			player.squishedcountdown = $ - 1
		end
	end
end)

--Fire Flower Item Replacement 
--To be replaced when the Roulette gets exposed
addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player.mo == nil then return end
		if player.mo.skin == "retromario" and player.mo.skin ~= "heavymagician" then
			
			--Instawhip Preventer (If jumping is on)
			if player.rings <= 0 and player.itemflags ~= 0 and CV_FindVar("RetroJumping").value == 1 and CV_FindVar("RetroJumpWhip").value == 0 and gametype ~= 1 then
				if localRetroJump == 1 and player.itemtype == KITEM_NONE and (player.cmd.buttons & BT_ATTACK) == BT_ATTACK then
					player.cmd.buttons = $ - BT_ATTACK
				end
			end
			--Back to base form if hit
			if player.flare == nil then return end
			if player.flare > 0 and P_PlayerInPain(player) then
				player.flarebuffer = 0
				player.flare = 0
				K_StripItems(player)
			end
			--Hud Flash Communicator
			if player.fireflowertimer == nil then return end
			if player.fireflowertimer < 35 and player.fireflowerflash == true then
				player.fireflowertimer = $ + 1
			elseif player.fireflowertimer == 35
				player.fireflowerflash = false
				if player.fireflowerflash == false then
					player.fireflowertimer = 0 
				end
			end
			--Fireball/Fireboost usage
			if player.flarewait == nil then return end
			if player.flare > 0 and player.flarewait == false then
				if (player.cmd.buttons & BT_ATTACK) == BT_ATTACK and player.flarebuffer == 0 and player.itemflags ~= 0
					if player.throwdir <= 0 then --Fireboost
						S_StartSoundAtVolume(player.mo, sfx_mbitfr, 255)
						S_StartSoundAtVolume(player.mo, sfx_mbitrm, 255)
						player.flamedash = $ + 25
					elseif player.throwdir == 1 and player.flare > 1 --Fireball (Shoots 2)
						S_StartSoundAtVolume(player.mo, sfx_mbitfr, 255)
						player.ballhogcharge = 20
						player.itemtype = KITEM_BALLHOG
						player.itemamount = 2
					elseif player.throwdir == 1 and player.flare == 1 --Fireball (Shoots 1)
						S_StartSoundAtVolume(player.mo, sfx_mbitfr, 255)
						player.ballhogcharge = 15
						player.itemtype = KITEM_BALLHOG
						player.itemamount = 1
					end
					player.flarebuffer = 1
					player.cmd.buttons = $ - BT_ATTACK
				elseif (player.cmd.buttons & BT_ATTACK) == BT_ATTACK and player.flarebuffer >= 1 --Buffer so charges aren't accidentally used
					if player.flarebuffer == 1 then
						if player.throwdir <= 0 then
							player.flare = $ - 1
						elseif player.throwdir == 1 and player.flare > 1 then
							player.flare = $ - 2
						elseif player.throwdir == 1 and player.flare == 1 then
							player.flare = $ - 1
						end
					end
					if player.itemtype ~= KITEM_FLAMESHIELD then
						player.itemtype = KITEM_FLAMESHIELD
						player.itemamount = 1
					end
					player.flarebuffer = 2
					player.cmd.buttons = $ - BT_ATTACK
				elseif (player.cmd.buttons & BT_ATTACK) == 0 and player.flarebuffer >= 1 --Second Buffer Layer just in case
					if player.itemtype ~= KITEM_FLAMESHIELD then
						player.itemtype = KITEM_FLAMESHIELD
						player.itemamount = 1
					end
					player.flarebuffer = 0
				end
			end
			--Fire Shield to Fire Power setup
			if player.itemtype == KITEM_FLAMESHIELD and player.flare == 0 and player.flaresetup == false then
				S_StartSoundAtVolume(mobj, sfx_mbitgr, 150, player)
				player.flarebuffer2 = 0
				player.flare = 10
				player.fireflowerflash = true
				player.fireflowertimer = 0
				player.flaresetup = true
			elseif player.flare == 0 and player.flaresetup == true then
				player.flarebuffer2 = 0
				player.flare = 0
				K_StripItems(player)
				player.flaresetup = false
			end
			--Obtainment Buffer
			if player.flaresetup == true and player.flarebuffer2 <= 10 then
				player.flarewait = true
				player.flarebuffer2 = $ + 1
			elseif player.flaresetup == true and player.flarebuffer2 > 10 then
				player.flarewait = false
			end
		end	
	end
end)

--Shield Effects Preventer
addHook("MobjThinker", function(mobj)
	if mobj.target.player.mo.skin == "retromario" and mobj.target.player.mo.skin ~= "heavymagician" then
		for i = 0,17 do
			if mobj.state == S_FLAMESHIELD1 + i then
				mobj.state = S_INVISIBLE
			end
		end
	end
end, MT_FLAMESHIELD)

--Count Current Display Players
function Retrofunc.countDisplayPlayers()
	local counter = 0
	for i=0,3 do
		local player = displayplayers[i]
		if player ~= nil then
			counter = $ + 1
		end
	end
	return counter
end

--Fire Flower Item Replacement Hud Function
function Retrofunc.drawFireFlower(v, p, c, displaynum, xoffset, yoffset, vidflags, smallitem, flipped)
	local itemhudnum = { [0]="ITMNA0",
					"ITMNB0","ITMNC0","ITMND0",
					"ITMNE0","ITMNF0","ITMNG0",
					"ITMNH0","ITMNI0","ITMNJ0"}
	
	if smallitem == false then
		if displayplayers[displaynum].flare == 1
			hud.disable("item")
			v.draw(xoffset, yoffset, v.cachePatch("K_ITBG"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("ITEMFLW"), vidflags)
			return
		elseif displayplayers[displaynum].flare > 1 or displayplayers[displaynum].itemtype == KITEM_FLAMESHIELD
			hud.disable("item")
			v.draw(xoffset, yoffset, v.cachePatch("K_ITMUL"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("K_ITBG"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("ITEMFLW"), vidflags)
			if displayplayers[displaynum].fireflowertimer % 2 == 1 then
				v.draw(xoffset, yoffset, v.cachePatch("ITEMFLS"), vidflags)
			end
			v.draw(28+xoffset, 41+yoffset, v.cachePatch("K_ITX"), vidflags)
			if displayplayers[displaynum].flare < 10 then
				v.draw(25+xoffset, 50+yoffset, v.cachePatch(itemhudnum[displayplayers[displaynum].flare]), vidflags)
			elseif displayplayers[displaynum].flare >= 10 then
				v.draw(25+xoffset, 50+yoffset, v.cachePatch(itemhudnum[displayplayers[displaynum].flare/10]), vidflags)
				v.draw(37+xoffset, 50+yoffset, v.cachePatch(itemhudnum[displayplayers[displaynum].flare%10]), vidflags)
			end
			return
		elseif displayplayers[displaynum].flare == 0 and hud.enabled("item") == false
			hud.enable("item")
			return
		end
	elseif smallitem == true then
		if displayplayers[displaynum].flare == 1
			hud.disable("item")
			v.draw(xoffset, yoffset, v.cachePatch("K_ISBG"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("ITMSFLW"), vidflags)
			return
		elseif displayplayers[displaynum].flare > 1 or displayplayers[displaynum].itemtype == KITEM_FLAMESHIELD
			hud.disable("item")
			v.draw(xoffset, yoffset, v.cachePatch("K_ISMUL"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("K_ISBG"), vidflags)
			v.draw(xoffset, yoffset, v.cachePatch("ITMSFLW"), vidflags)
			if displayplayers[displaynum].fireflowertimer % 2 == 1 then
				v.draw(xoffset, yoffset, v.cachePatch("ITMSFLS"), vidflags)
			end
			if flipped == false then
				v.drawString(24+xoffset,31+yoffset,"x"..displayplayers[displaynum].flare, vidflags, "left")
			else
				v.drawString(xoffset-46,31+yoffset,"x"..displayplayers[displaynum].flare, vidflags, "left")
			end
			return
		elseif displayplayers[displaynum].flare == 0 and hud.enabled("item") == false
			hud.enable("item")
			return
		end
	end
end

--Jump Meter Hud Function
function Retrofunc.drawJumpMeter(v, p, c, displaynum, xoffset, yoffset, vidflags, small)
	local jumptimer = TICRATE*CV_FindVar("RetroRechargeTime").value
	if displayplayers[displaynum].exiting == 1 then return end
	if gametype ==  1 then return end
	if CV_FindVar("RetroJumping").value == 1 then
		if localRetroJump == 0 then return end
		if small == false then
			v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT, v.cachePatch("HUDJUMP"), vidflags)
			if displayplayers[displaynum].jumpfirststop == true and Retrofunc.countCurrentPlayers() > 1 then
				v.drawString(xoffset+18,yoffset+16,"X", vidflags|V_REDMAP, "center")
			end
			for i = 1,11 do
				if displayplayers[displaynum].jumprechargetimer == nil then return end 
				if displayplayers[displaynum].jumprechargetimer == jumptimer and displayplayers[displaynum].jumpchargeflash == true then
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT, v.cachePatch("HUDJT12"), vidflags)
				elseif displayplayers[displaynum].jumprechargetimer == jumptimer and displayplayers[displaynum].jumpchargeflash == false then
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT, v.cachePatch("HUDJT11"), vidflags)
				elseif displayplayers[displaynum].jumprechargetimer >= i*(jumptimer/11) and displayplayers[displaynum].jumprechargetimer < (i+1)*(jumptimer/11)
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT, v.cachePatch("HUDJT"+i), vidflags)
				end
			end
			if CV_FindVar("RetroDebug").value == 1 
				v.drawString(xoffset+18,yoffset+7,displayplayers[displaynum].jumprechargetimer, vidflags, "center")
			end
		elseif small == true then
			v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT/2, v.cachePatch("HUDJUMP"), vidflags)
			if displayplayers[displaynum].jumpfirststop == true and Retrofunc.countCurrentPlayers() > 1 then
				v.drawString(xoffset+9,yoffset+5,"X", vidflags|V_REDMAP, "center")
			end
			for i = 1,9 do
				if displayplayers[displaynum].jumprechargetimer == nil then return end 
				if displayplayers[displaynum].jumprechargetimer >= i*(jumptimer/12) and displayplayers[displaynum].jumprechargetimer < (i+1)*(jumptimer/12)
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT/2, v.cachePatch("HUDJT"+i), vidflags)
				elseif displayplayers[displaynum].jumprechargetimer >= 11*(jumptimer/12) and displayplayers[displaynum].jumprechargetimer < jumptimer then
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT/2, v.cachePatch("HUDJT11"), vidflags)
				elseif displayplayers[displaynum].jumprechargetimer == jumptimer and displayplayers[displaynum].jumpchargeflash == true then
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT/2, v.cachePatch("HUDJT12"), vidflags)
				elseif displayplayers[displaynum].jumprechargetimer == jumptimer and displayplayers[displaynum].jumpchargeflash == false then
					v.drawScaled(FRACUNIT*xoffset,FRACUNIT*yoffset,FRACUNIT/2, v.cachePatch("HUDJT11"), vidflags)
				end
			end
			if CV_FindVar("RetroDebug").value == 1
				if displayplayers[displaynum].jumpfirststop == true then
					v.drawString(xoffset+9,yoffset+5,displayplayers[displaynum].jumprechargetimer, vidflags|V_REDMAP, "center")
				elseif displayplayers[displaynum].jumpfirststop == false then
					v.drawString(xoffset+9,yoffset+5,displayplayers[displaynum].jumprechargetimer, vidflags, "center")
				end
			end
		end
	end
end

--Hud Stuff
hud.add(function(v, p, c)
	local retrodebug = CV_FindVar("RetroDebug").value
	local screenmode
	
	if Retrofunc.countDisplayPlayers() == 1
		screenmode = 1
	elseif Retrofunc.countDisplayPlayers() == 2
		screenmode = 2
	elseif Retrofunc.countDisplayPlayers() >= 3
		screenmode = 3
	end
	
	if CV_FindVar("RetroJumping").value == 0 then return end
	if p.mo == nil then return end
	--All Custom hud drawing stuff
	if screenmode == 1 --Single Player
		if displayplayers[0].mo == nil then return end
		if displayplayers[0].mo.skin == "retromario" and displayplayers[0].skin ~= "heavymagician" then--Player 1 (Main)
			Retrofunc.drawFireFlower(v, p, c, 0, 5, 5, V_SNAPTOLEFT|V_SNAPTOTOP, false, false)
			Retrofunc.drawJumpMeter(v, p, c, 0, 100, 158, V_SNAPTOLEFT|V_SNAPTOBOTTOM, false)
		end
	elseif screenmode == 2 --2 Player 
		if displayplayers[0].mo == nil or displayplayers[1].mo == nil then return end
		if displayplayers[0].mo.skin == "retromario" and displayplayers[0].skin ~= "heavymagician" then --Player 1(Top)
			Retrofunc.drawFireFlower(v, p, c, 0, 5, -2, V_SNAPTOLEFT|V_SNAPTOTOP, false, false)
			Retrofunc.drawJumpMeter(v, p, c, 0, 90, 78, V_SNAPTOLEFT, true)
		end
		if displayplayers[1].mo.skin == "retromario" and displayplayers[1].skin ~= "heavymagician" then --Player 2 (Bottom)
			Retrofunc.drawFireFlower(v, p, c, 1, 5, 98, V_SNAPTOLEFT, false, false)
			Retrofunc.drawJumpMeter(v, p, c, 1, 90, 178, V_SNAPTOLEFT|V_SNAPTOBOTTOM, true)
		end
	elseif screenmode == 3 --3/4 Player 
		local switcher
		if Retrofunc.countDisplayPlayers() == 3
			switcher = false
			if displayplayers[0].mo == nil or displayplayers[1].mo == nil or displayplayers[2].mo == nil then return end
		elseif Retrofunc.countDisplayPlayers() == 4
			switcher = true
			if displayplayers[0].mo == nil or displayplayers[1].mo == nil or displayplayers[2].mo == nil or displayplayers[3].mo == nil then return end
		end
		if displayplayers[0].mo.skin == "retromario" and displayplayers[0].skin ~= "heavymagician" then --Player 1 (Top Left)
			Retrofunc.drawFireFlower(v, p, c, 0, -9, -8, V_SNAPTOLEFT|V_SNAPTOTOP, true, false)
			Retrofunc.drawJumpMeter(v, p, c, 0, 50, 80, V_SNAPTOLEFT, true)
		end
		if displayplayers[1].mo.skin == "retromario" and displayplayers[1].skin ~= "heavymagician" then --Player 2 (Top Right)
			Retrofunc.drawFireFlower(v, p, c, 1, 329, -8, V_SNAPTORIGHT|V_SNAPTOTOP|V_FLIP, true, true)
			Retrofunc.drawJumpMeter(v, p, c, 1, 255, 80, V_SNAPTORIGHT, true)
		end
		if displayplayers[2].mo.skin == "retromario" and displayplayers[2].skin ~= "heavymagician" then --Player 3 (Bottom Left)
			Retrofunc.drawFireFlower(v, p, c, 2, -9, 92, V_SNAPTOLEFT, true, false)
			Retrofunc.drawJumpMeter(v, p, c, 0, 50, 180, V_SNAPTOLEFT|V_SNAPTOBOTTOM, true)
		end
		if switcher == false then return end --Special switch incase 4th Player doesnt exist
		if displayplayers[3].mo.skin == "retromario" and displayplayers[3].skin ~= "heavymagician" then --Player 4 (Bottom Right)
			Retrofunc.drawFireFlower(v, p, c, 3, 329, 92, V_SNAPTORIGHT|V_FLIP, true, true)
			Retrofunc.drawJumpMeter(v, p, c, 0, 255, 180, V_SNAPTORIGHT|V_SNAPTOBOTTOM, true)
		end
	end
		--Debug Hud
		if retrodebug == 1 then
			v.drawString(40,0,"Retro Debug Screen", V_SNAPTOLEFT, "left")
			v.drawString(40,10,"Jumping: " .. CV_FindVar("RetroJumping").string, V_SNAPTOLEFT, "left")
			v.drawString(40,20,"Jump Recharge Time: " .. CV_FindVar("RetroRechargeTime").value, V_SNAPTOLEFT, "left")
			v.drawString(40,30,"Jump Height: " .. CV_FindVar("RetroJumpHeight").value, V_SNAPTOLEFT, "left")
			v.drawString(40,40,"Early Jump: " .. CV_FindVar("RetroEarlyJump").string, V_SNAPTOLEFT, "left")
			v.drawString(40,50,"Jump Whip: " .. CV_FindVar("RetroJumpWhip").string, V_SNAPTOLEFT, "left")
			v.drawString(40,60,"Jump Attack: " .. tostring(p.jumpattack), V_SNAPTOLEFT, "left")
			v.drawString(40,70,"Flare Count: " .. p.flare, V_SNAPTOLEFT, "left")
			v.drawString(40,80,"Flare Buffer: " .. p.flarebuffer, V_SNAPTOLEFT, "left")
		end
end, "game")

--Item Reskin Function (To be used into specific MobjThinkers)
local retroitemthinker = function(mo)
	if localRetroReskin == 0 then return
	elseif mo and mo.valid and mo.target and (mo.target.skin == "retromario" or localRetroReskin == 2)
		if not mo.init then
			if mo.type == MT_RING then
				mo.state = S_RETROCOINSTART
				mo.spritexscale = FRACUNIT*3
				mo.spriteyscale = FRACUNIT*3
				mo.pointtimer = 0
			end
			if mo.type == MT_BANANA or mo.type == MT_BANANA_SHIELD then
				mo.state = S_RETROPOISON
			end
			if mo.type == MT_BALLHOG then
				mo.state = S_RETROFIREBALL
				if mo.fballoffset == nil then mo.fballoffset = 0 end
				if mo.fballreverse == nil then mo.fballreverse = false end
			end
			if mo.type == MT_ORBINAUT or mo.type == MT_ORBINAUT_SHIELD then
				mo.state = S_RETROSHELL
			end
			if mo.type == MT_JAWZ or mo.type == MT_JAWZ_SHIELD then
				mo.state = S_RETROBULLET
			end
			mo.init = true
		end
		if mo.state == S_RETROFIREBALL then
			if mo.fballoffset ~= nil then
				if mo.fballreverse == false then
					if mo.fballoffset < 5 then
						mo.fballoffset = $ + 1
					elseif mo.fballoffset >= 5 then
						mo.fballreverse = true
					end
				elseif mo.fballreverse == true then
					if mo.fballoffset > 0 then
						mo.fballoffset = $ - 1
					elseif mo.fballoffset <= 0 then
						mo.fballreverse = false
					end
				end
				if mo.fballoffset <= 4 then
					mo.spriteyoffset = 10 * (mo.fballoffset * FRACUNIT)
				elseif mo.fballoffset > 4 then
					mo.spriteyoffset = 10 * (FRACUNIT * (4 + ( (1/4) * (4 - mo.fballoffset))))
				end
			end
		end
		if mo.state == S_RETROPOINTS and mo.type == MT_RING then
			mo.state = S_INVISIBLE
			P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_RETROPOINTS)
		end
		mo.lastx = $ or mo.x
		mo.lasty = $ or mo.y
		mo.lastz = $ or mo.z
		mo.color = mo.target.player.skincolor
	end
end

--Points Floating Upwards
addHook("MobjThinker", function(mo)
if mo.state == S_RETROPOINTS then
	mo.fuse = 35
	mo.spritexscale = FRACUNIT*3
	mo.spriteyscale = FRACUNIT*3
	mo.spriteyoffset = $ + FRACUNIT
end
end, MT_RETROPOINTS)

addHook("MobjThinker", retroitemthinker, MT_RING)
addHook("MobjThinker", retroitemthinker, MT_BANANA)
addHook("MobjThinker", retroitemthinker, MT_BANANA_SHIELD)
addHook("MobjThinker", retroitemthinker, MT_BALLHOG)
addHook("MobjThinker", retroitemthinker, MT_ORBINAUT)
addHook("MobjThinker", retroitemthinker, MT_ORBINAUT_SHIELD)
addHook("MobjThinker", retroitemthinker, MT_JAWZ)
addHook("MobjThinker", retroitemthinker, MT_JAWZ_SHIELD)